import typing as tp


class Position:
    x: int
    y: int

    def __init__(self, x: int, y: int) -> None:
        self.x = x
        self.y = y

    def __str__(self) -> str:
        return f"({self.x}, {self.y})"


class Route:
    positions: tp.List[Position]

    def __init__(self, positions: tp.List[Position]) -> None:
        self.positions = positions


def isvalid_bishop_move(position: Position):
    squares = []
    y, x = position.y, position.x

    directions = [
        zip(range(x + 1, 8), range(y + 1, 8)),
        zip(range(x - 1, -1, -1), range(y + 1, 8)),
        zip(range(x + 1, 8), range(y - 1, -1, -1)),
        zip(range(x - 1, -1, -1), range(y - 1, -1, -1)),
    ]

    for direction in directions:
        for square in direction:
            squares.append(Position(square[0], square[1]))

    return squares


pos_x_compare = {
    "A": 0,
    "B": 1,
    "C": 2,
    "D": 3,
    "E": 4,
    "F": 5,
    "G": 6,
    "H": 7,
}

start_pos, finish_pos, amount_of_moves = input().split(" ")
amount_of_moves = int(amount_of_moves)
# start_pos, finish_pos, amount_of_moves = ("D2", "D4", 3)

starting_position = Position(x=pos_x_compare[[x for x in start_pos][0]], y=int([x for x in start_pos][1]) - 1)
finishing_position = Position(x=pos_x_compare[[x for x in finish_pos][0]], y=int([x for x in finish_pos][1]) - 1)
dct_of_routes = {}
list_of_routes = []


def draw_graph(pos: Position, finishing_pos: Position, moves: int = 0, list_of_prev_pos: tp.List = None) -> tp.List:
    if moves >= amount_of_moves:
        list_of_prev_pos = list(set(list_of_prev_pos))
        list_of_prev_pos.append(pos)
        if pos.x == finishing_pos.x and pos.y == finishing_pos.y:
            list_of_routes.append(Route(list_of_prev_pos))
        list_of_prev_pos = list_of_prev_pos[:2]
        return list_of_prev_pos

    all_possible_positions = isvalid_bishop_move(pos)
    dct_of_routes[str(pos)] = all_possible_positions
    for new_pos in all_possible_positions:
        if not list_of_prev_pos:
            list_of_prev_pos = [pos]
        else:
            list_of_prev_pos.append(pos)
        list_of_prev_pos = draw_graph(new_pos, finishing_pos, moves + 1, list_of_prev_pos)


draw_graph(starting_position, finishing_position)
print(len(list_of_routes))
